<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license   GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die('Restricted access');

require_once JPATH_ROOT . '/components/com_cobalt/library/php/helpers/helper.php';

jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

// forum section
define('_SECTION', 6);

// topic type
define('_TYPE', 7);

// Fields
define('_F_TEXT', 42);
define('_F_TYPE', 46);
define('_F_STATUS', 50);
define('_F_ANSWER', 51);

// Categories
define('_C_COBALT8', 37);
define('_C_COBALT7', 38);
define('_C_EMERALD8', 47);
define('_C_EMERALD9', 39);

class plgMintAd2mj extends JPlugin
{
	/**
	 * @var JTable
	 */
	private $record;

	function plgMintAd2mj(&$subject, $params)
	{
		parent::__construct($subject, $params);

		JTable::addIncludePath(JPATH_ROOT . '/administrator/components/com_cobalt/tables');
		JModelLegacy::addIncludePath(JPATH_ROOT . '/components/com_cobalt/models');

		$this->record   = JTable::getInstance('Record', 'CobaltTable');
		$this->category = JTable::getInstance('Record_category', 'CobaltTable');
		$this->values   = JTable::getInstance('Record_values', 'CobaltTable');
		$this->bookmark = JTable::getInstance('Favorites', 'CobaltTable');
		$this->follow   = JTable::getInstance('Subscribe', 'CobaltTable');
		$this->comments = JTable::getInstance('Cobcomments', 'CobaltTable');
		$this->fields   = $this->getFields();

		$this->cats_titles = array(70 => 'Cobalt 7', 77 => 'Cobalt 8', 71 => 'Emerald 8', 79 => 'Emerald 9');
		$this->cats_ids    = array(70 => _C_COBALT7, 77 => _C_COBALT8, 71 => _C_EMERALD8, 79 => _C_EMERALD9);
		$this->topic_types = array(1 => 'TT_QUESTION', 2 => 'TT_IDEA', 3 => 'TT_BUG', 4 => 'TT_TESTIMONY');


		// 1 => 'TS_PENDING',
		// 2 => 'TS_PROGRESS',
		// 5 => 'TS_CLOSED',
		// 3 => 'TS_SOLVED',
		// 4 => 'TS_ACCEPTED'

		$statuses[4] = array();
		$statuses[1] = array(
			1 => 1, 2 => 3
		);
		$statuses[2] = array(
			1 => 1, 2 => 2, 4 => 3, 3 => 5, 5 => 4
		);
		$statuses[3] = array(
			1 => 1, 2 => 2, 4 => 3, 3 => 5
		);

		$this->topic_status = $statuses;
	}

	function onToolsGetIcons($context)
	{
		$db = JFactory::getDBO();

		$i = 0;

		$i++;
		$icon[$i]              = new stdClass();
		$icon[$i]->label       = JText::_('Migrate AD');
		$icon[$i]->icon        = 'plugins/mint/toolset/icons/db.png';
		$icon[$i]->description = JText::_('Migrate AngelDest Topics to MintJoomla forum');
		$icon[$i]->name        = 'ad2mj';
		$icon[$i]->id          = 22;
		$icon[$i]->height      = 200;


		return $icon;
	}

	protected function _getTool($id)
	{
		$tools = $this->onToolsGetIcons('1');
		foreach($tools as $tool)
		{
			if($id == $tool->id)
			{
				return $tool;
			}
		}
	}

	public function onToolGetForm($context, $form, $name, $id)
	{
		if($name != 'ad2mj')
		{
			return;
		}

		$tool = $this->_getTool($id);

		if(!JFile::exists(dirname(__FILE__) . '/saved/' . $id . '.conf'))
		{
			$a = '';
			JFile::write(dirname(__FILE__) . '/saved/' . $id . '.conf', $a);
		}

		$params = new JRegistry();
		$params->loadFile(dirname(__FILE__) . '/saved/' . $id . '.conf');

		$form_object = JForm::getInstance('plg_ad2mj.form', JPATH_PLUGINS . '/mint/ad2mj/helpers/forms.xml', array('control' => 'jform'));
		$form        = MEFormHelper::renderFieldset($form_object, 'ad2mj' . $id, $params, NULL, FORM_STYLE_TABLE);
	}

	function onToolExecute($name, $id)
	{
		if($name != 'ad2mj')
		{
			return;
		}


		$params = new JRegistry('');
		if(@$_POST['jform'])
		{
			$params->loadArray(@$_POST['jform']);
		}

		$content = $params->toString();
		JFile::write(dirname(__FILE__) . '/saved/' . $id . '.conf', $content);

		switch($id)
		{
			case 22:
				$this->migrate($params);
				break;
		}
	}

	private function migrate($params)
	{
		$this->cleanDB();
		$this->import();
	}

	private function import()
	{
		$db = JFactory::getDbo();
		$db->setQuery("SELECT * FROM users_topics LIMIT 1");
		$list = $db->loadObjectList();

		if(empty($list))
		{
			return;
		}

		foreach($list AS $record)
		{

			if(empty($this->cats_ids[$record->product_id]))
			{
				continue;
			}

			$this->record->reset();
			$this->record->id = NULL;

			$data['title']      = $record->title;
			$data['type_id']    = _TYPE;
			$data['section_id'] = _SECTION;
			$data['published']  = 1;
			$data['ctime']      = $record->ctime;
			$data['mtime']      = $record->mtime;
			$data['user_id']    = $this->getUser($record->user_id);
			$data['access']     = 1;
			$data['ip']         = $record->ip;
			$data['hits']       = $record->hits;

			$category                      = array($this->cats_ids[$record->product_id] => $this->cats_titles[$record->product_id]);
			$data['categories']            = json_encode($category);
			$_REQUEST['jform']['category'] = $this->cats_ids[$record->product_id];

			$fields_data = array(
				_F_TEXT   => $this->toMarkdown($record->text),
				_F_TYPE   => $this->topic_types[$record->topic_type],
				_F_ANSWER => $this->toMarkdown($record->answer),
				_F_STATUS => (int)@$this->topic_status[$record->topic_type][$record->state1] ? (int)@$this->topic_status[$record->topic_type][$record->state1] : 3
			);

			$data['fields'] = json_encode($fields_data);

			$this->record->bind($data);
			if(!$this->record->check_cli())
			{
				echo $this->record->getError();
				exit;
			}
			$this->record->store();

			$db->setQuery("DELETE FROM users_topics WHERE id = " . $record->id);
			$db->query();


			$this->saveCategories($this->cats_ids[$record->product_id]);
			$this->saveFields($fields_data);
			$this->saveBookmarks($record->id);
			$this->saveFollows($record->id);
			$this->saveComments($record->id);

		}

		//$this->import();
	}

	private function saveComments($id)
	{
		$db = JFactory::getDbo();
		$db->setQuery('SELECT * FROM users_comments WHERE topic_id = ' . $id);

		$list = $db->loadObjectList();
		foreach($list As $item)
		{
			$user = $this->getUser($item->user_id);

			if(!$item->text)
			{
				continue;
			}

			$data = array(
				'user_id'    => $user,
				'record_id'  => $this->record->id,
				'section_id' => _SECTION,
				'type_id'    => _TYPE,
				'comment'    => $this->toMarkdown($item->text),
				'level'      => 1,
				'parent_id'  => 1
			);

			$this->comments->load($data);
			if(!$this->comments->id)
			{

				$this->comments->bind($data);
				$this->comments->ctime     = $item->ctime;
				$this->comments->langs     = 'en-GB';
				$this->comments->published = 1;
				$this->comments->access    = 1;
				$this->comments->private   = $item->state;
				$this->comments->parent_id = 1;


				$this->comments->store();
				$this->comments->reset();
				$this->comments->id = NULL;
			}

		}

		$db->setQuery('DELETE FROM users_comments WHERE topic_id = ' . $id);
		$db->query();

		$db->setQuery('UPDATE #__js_res_comments SET parent_id = 1  WHERE record_id = ' . $this->record->id);
		$db->query();

		$db->setQuery('UPDATE #__js_res_record SET comments = (SELECT COUNT(id)
			FROM #__js_res_comments WHERE record_id = ' . $this->record->id . ' AND published = 1) WHERE id = ' . $this->record->id);
		$db->query();

	}

	private function saveFollows($id)
	{
		$db = JFactory::getDbo();
		$db->setQuery('SELECT * FROM users_subscriptions WHERE topic_id = ' . $id);

		$list = $db->loadObjectList();

		foreach($list As $item)
		{
			$user = $this->getUser($item->user_id);

			if(!$user)
			{
				continue;
			}

			$data = array(
				'user_id'    => $user,
				'ref_id'     => $this->record->id,
				'section_id' => _SECTION,
				'type'       => 'record'
			);

			$this->follow->load($data);
			if(!$this->follow->id)
			{
				$data['ctime'] = JFactory::getDate()->toSql();

				$this->follow->bind($data);
				$this->follow->store();
				$this->follow->reset();
				$this->follow->id = NULL;
			}

		}

		$db->setQuery('DELETE FROM users_subscriptions WHERE topic_id = ' . $id);
		$db->query();
	}

	private function saveBookmarks($id)
	{
		$db = JFactory::getDbo();
		$db->setQuery('SELECT * FROM users_bookmarks WHERE topic_id = ' . $id);

		$list = $db->loadObjectList();

		foreach($list As $item)
		{
			$user = $this->getUser($item->user_id);

			if(!$user)
			{
				continue;
			}

			$data = array(
				'user_id'    => $user,
				'record_id'  => $this->record->id,
				'section_id' => _SECTION,
				'type_id'    => _TYPE
			);

			$this->bookmark->load($data);
			if(!$this->bookmark->id)
			{
				$data['ctime'] = JFactory::getDate()->toSql();

				$this->bookmark->bind($data);
				$this->bookmark->store();
				$this->bookmark->reset();
				$this->bookmark->id = NULL;
			}

		}

		$db->setQuery('DELETE FROM users_bookmarks WHERE topic_id = ' . $id);
		$db->query();
	}

	private function saveFields($fields_data)
	{
		$type    = $this->getType();
		$section = $this->getSection();

		$field_ids = array_keys($fields_data);

		$this->values->clean($this->record->id, $field_ids);

		foreach($this->fields as $field)
		{
			if(empty($fields_data[$field->id]))
			{
				continue;
			}

			if(!in_array($field->id, $field_ids))
			{
				continue;
			}

			$file = JPATH_ROOT . DIRECTORY_SEPARATOR . 'components/com_cobalt/fields/' . $field->field_type . '/' . $field->field_type . '.php';
			if(!JFile::exists($file))
			{
				JError::raiseWarning(404, JText::sprintf("CFIELDNOTFOUND", $field->field_type));
				continue;
			}
			require_once $file;

			$name = 'JFormFieldC' . ucfirst($field->field_type);
			$obj  = new $name($field, $fields_data[$field->id]);

			if($obj->params->get('core.searchable'))
			{
				$data = $obj->onPrepareFullTextSearch($obj->value, $this->record, $type, $section);
				if(is_array($data))
				{
					$data = implode(', ', $data);
				}
				$fulltext[$obj->id] = $data;
			}


			$values = $obj->onStoreValues(get_object_vars($this->record), $this->record);
			if(empty($values))
			{
				continue;
			}

			settype($values, 'array');
			foreach($values as $key => $value)
			{
				$this->values->store_value($value, $key, $this->record, $obj);
				$this->values->reset();
				$this->values->id = NULL;
			}
		}

		$user = JFactory::getUser($this->record->user_id);

		if($section->params->get('more.search_title'))
		{
			$fulltext[] = $this->record->title;
		}
		if($section->params->get('more.search_name'))
		{
			$fulltext[] = $user->get('name');
			$fulltext[] = $user->get('username');
		}
		if($section->params->get('more.search_email'))
		{
			$fulltext[] = $user->get('email');
		}

		if(!empty($fulltext))
		{
			$this->record->fieldsdata = strip_tags(implode(', ', $fulltext));
			$this->record->store();
		}

		unset($fulltext, $user);

	}

	private function saveCategories($catid)
	{
		$cat_data = array(
			'record_id'  => $this->record->id, 'catid' => $catid,
			'section_id' => $this->record->section_id, 'ordering' => 0
		);
		$this->category->load($cat_data);

		if(!$this->category->id)
		{
			$this->category->save($cat_data);
		}

		$this->category->reset();
		$this->category->id = NULL;
	}

	private function getType()
	{
		$db = JFactory::getDbo();

		$db->setQuery('SELECT * FROM #__js_res_types WHERE id = ' . _TYPE);

		$type         = $db->loadObject();
		$type->params = new JRegistry($type->params);

		return $type;
	}

	private function getSection()
	{
		$db = JFactory::getDbo();

		$db->setQuery('SELECT * FROM #__js_res_sections WHERE id = ' . _SECTION);

		$section         = $db->loadObject();
		$section->params = new JRegistry($section->params);

		return $section;
	}

	private function getFields()
	{
		$db = JFactory::getDbo();

		$db->setQuery('SELECT * FROM #__js_res_fields WHERE type_id = ' . _TYPE);

		return $db->loadObjectList();
	}

	private function cleanDB()
	{
		$db = JFactory::getDbo();

		$db->setQuery('DELETE FROM users_subscriptions WHERE provider_id != 101 OR provider_id IS NULL');
		$db->query();

		$db->setQuery('DELETE FROM users_topics WHERE provider_id != 101 OR provider_id IS NULL OR parent > 0 OR state2 = 1');
		$db->query();

		$db->setQuery('DELETE FROM users_comments WHERE provider_id != 101 OR provider_id IS NULL');
		$db->query();

		$db->setQuery('DELETE FROM users_bookmarks WHERE provider_id != 101 OR provider_id IS NULL');
		$db->query();

	}

	private function getUser($user_id)
	{
		static $users = array();

		if(array_key_exists($user_id, $users))
		{
			return $users[$user_id];
		}

		$db = JFactory::getDbo();

		$db->setQuery("SELECT u.id FROM #__users AS u WHERE u.email = (SELECT o.email FROM users AS o WHERE o.id = " . $db->quote($user_id) . ")");
		$users[$user_id] = $db->loadResult();

		return $users[$user_id];
	}

	private function toMarkdown($text)
	{
		if(empty($text))
		{
			return NULL;
		}


		$from = array(
			'[b]', '[/b]', '[list]', '[/list]', '[*]', "\n", "\r"
		);

		$to = array(
			'**', '**', "\n", "\n", '* ', "\n\n", ''
		);

		$text = str_replace($from, $to, $text);

		$text = preg_replace('/\[img\](.*)\[\/img\]/iU', "\n![](\\1)\n", $text);
		$text = preg_replace('/\[code=([^\]]*)\](.*)\[\/code\]/isU', "\n~~~~~ \\1\n\\2\n~~~~~\n", $text);
		$text = preg_replace('/\[url href="([^"]*)"\](.*)\[\/url\]/isU', "[\\2](\\1)", $text);
		if(preg_match_all('/\[quote([^\]]*)\](.*)\[\/quote\]/isU', $text, $match))
		{
			$out = array();

			foreach($match[0] AS $key => $replace)
			{
				$quote = @$match[2][$key];
				$quote = explode("\n", str_replace("\r", "", $quote));

				foreach($quote as $q)
				{
					if(empty($q))
					{
						continue;
					}

					$out[] = "> ".$q;
				}
				if($out && !empty($match[1][$key]))
				{
					array_shift($out, '> <small>'.str_replace('=', '', $match[1][$key]).'</small>');
				}

				$text = str_replace($replace, implode("\n\n", $out), $text);
			}
		}

		$from = array(
			'~~~~~ html4strict', "\n\n- ", "\n\n~~~~~"
		);

		$to = array(
			'~~~~~ html', "\n- ", "\n~~~~~"
		);

		$text = str_replace($from, $to, $text);

		$text = preg_replace("/~~~~~ ([a-z0-9]*)\n\n/iU", "~~~~~ \\1\n", $text);

		while(TRUE)
		{
			if(strpos($text, "\n\n\n") === FALSE)
			{
				break;
			}
			$text = str_replace("\n\n\n", "\n\n", $text);
		}

		return $text;
	}
}